# HG changeset patch
# User Gregory Szorc <gregory.szorc@gmail.com>
# Date 1519181758 28800
#      Tue Feb 20 18:55:58 2018 -0800
# Branch stable
# Node ID ff4bc0ab6740cdba89be7bffc235e09f3719426e
# Parent  e3c228b4510db166179fbc3e8a15033adb3104aa
wireproto: check permissions when executing "batch" command (BC) (SEC)

For as long as the "batch" command has existed (introduced by
bd88561afb4b and first released as part of Mercurial 1.9), that command
(like most wire commands introduced after 2008) lacked an entry in
the hgweb permissions table. And since we don't verify permissions if
an entry is missing from the permissions table, this meant that
executing a command via "batch" would bypass all permissions
checks.

The security implications are significant: a Mercurial HTTP server
would allow writes via "batch" wire protocol commands as long as
the HTTP request were processed by Mercurial and the process running
the Mercurial HTTP server had write access to the repository. The
Mercurial defaults of servers being read-only and the various web.*
config options to define access control were bypassed.

In addition, "batch" could be used to exfiltrate data from servers
that were configured to not allow read access.

Both forms of permissions bypass could be mitigated to some extent
by using HTTP authentication. This would prevent HTTP requests from
hitting Mercurial's server logic. However, any authenticated request
would still be able to bypass permissions checks via "batch" commands.

The easiest exploit was to send "pushkey" commands via "batch" and
modify the state of bookmarks, phases, and obsolescence markers.
However, I suspect a well-crafted HTTP request could trick the server
into running the "unbundle" wire protocol command, effectively
performing a full `hg push` to create new changesets on the remote.

This commit plugs this gaping security hole by having the "batch"
command perform permissions checking on each sub-command that is
being batched. We do this by threading a permissions checking
callable all the way to the protocol handler. The threading is a
bit hacky from a code perspective. But it preserves API compatibility,
which is the proper thing to do on the stable branch.

One of the subtle things we do is assume that a command with an
undefined permission is a "push" command. This is the safest thing to
do from a security perspective: we don't want to take chances that
a command could perform a write even though the server is configured
to not allow writes.

As the test changes demonstrate, it is no longer possible to bypass
permissions via the "batch" wire protocol command.

.. bc::

   The "batch" wire protocol command now enforces permissions of
   each invoked sub-command. Wire protocol commands must define
   their operation type or the "batch" command will assume they
   can write data and will prevent their execution on HTTP servers
   unless the HTTP request method is POST, the server is configured
   to allow pushes, and the (possibly authenticated) HTTP user is
   authorized to perform a push.

---
 mercurial/hgweb/hgweb_mod.py |    4 +++-
 mercurial/hgweb/protocol.py  |    1 +
 mercurial/wireproto.py       |   13 +++++++++++++
 3 files changed, 17 insertions(+), 1 deletion(-)

--- a/mercurial/hgweb/hgweb_mod.py
+++ b/mercurial/hgweb/hgweb_mod.py
@@ -160,8 +160,10 @@ class hgweb(object):
             try:
                 if query:
                     raise ErrorResponse(HTTP_NOT_FOUND)
+
+                req.checkperm = lambda op: self.check_perm(req, op)
                 if cmd in perms:
-                    self.check_perm(req, perms[cmd])
+                    req.checkperm(perms[cmd])
                 return protocol.call(self.repo, req, cmd)
             except ErrorResponse, inst:
                 # A client that sends unbundle without 100-continue will
--- a/mercurial/hgweb/protocol.py
+++ b/mercurial/hgweb/protocol.py
@@ -17,6 +17,7 @@ class webproto(object):
         self.req = req
         self.response = ''
         self.ui = ui
+        self.checkperm = req.checkperm
     def getargs(self, args):
         knownargs = self._args()
         data = {}
--- a/mercurial/wireproto.py
+++ b/mercurial/wireproto.py
@@ -379,6 +379,17 @@ def batch(repo, proto, cmds, others):
                 n, v = a.split('=')
                 vals[n] = unescapearg(v)
         func, spec = commands[op]
+
+        # If the protocol supports permissions checking, perform that
+        # checking on each batched command.
+        # TODO formalize permission checking as part of protocol interface.
+        if util.safehasattr(proto, 'checkperm'):
+            # Assume commands with no defined permissions are writes / for
+            # pushes. This is the safest from a security perspective because
+            # it doesn't allow commands with undefined semantics from
+            # bypassing permissions checks.
+            proto.checkperm(permissions.get(op, 'push'))
+
         if spec:
             keys = spec.split()
             data = {}
@@ -669,6 +680,8 @@ commands = {
     'unbundle': (unbundle, 'heads'),
 }
 
+# TODO define a more appropriate permissions type to use for this.
+permissions['batch'] = 'pull'
 permissions['between'] = 'pull'
 permissions['branches'] = 'pull'
 permissions['capabilities'] = 'pull'
